package zdb

import (
	"errors"
	"github.com/jackc/pgx/v5"
)

var ErrNoRows = pgx.ErrNoRows

func IsEmpty(err error) bool {
	return errors.Is(err, ErrNoRows)
}

type Opts interface {
	Opts() (sql string, args map[string]any)
}

type Logger interface {
	Printf(format string, v ...any)
}
