package zutils

import "strings"

func Uniq[T comparable](s []T) []T {
	keys := make(map[T]bool)
	var list []T

	for _, entry := range s {
		if _, value := keys[entry]; !value {
			keys[entry] = true
			list = append(list, entry)
		}
	}

	return list
}

func Contains(s string, sl []string) bool {
	for _, s2 := range sl {
		if strings.Contains(s, s2) {
			return true
		}
	}

	return false
}

func Remove[T comparable](slice []T, s int) []T {
	return append(slice[:s], slice[s+1:]...)
}
